// Copyright IBM Corp. 2016. All Rights Reserved.
// Node module: apiconnect
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.

var Promise = require('bluebird');
var mkdirp = Promise.promisify(require('mkdirp'));
var os = require('os');
var osenv = require('osenv');
var path = require('path');

function defer() {
  var deferred = {};
  deferred.promise = new Promise(function(resolve, reject) {
    deferred.reject = reject;
    deferred.resolve = resolve;
  });
  return deferred;
}
exports.defer = defer;

function mktmpdir() {
  var tmpdir = path.join(os.tmpdir(), Math.random() + '-' + (+new Date()));
  return mkdirp(tmpdir);
}
exports.mktmpdir = mktmpdir;

function getConfigDir() {
  var configDir = process.env.APIMESH_CLI_CONFIG_PATH ||
    path.resolve(osenv.home(), '.apiconnect');
  mkdirp.sync(configDir);
  return configDir;
}
exports.getConfigDir = getConfigDir;
